package com.steerinfo.baseinfo.meterbaseuserspotconfig.controller;

import com.steerinfo.baseinfo.meterbaseuserspot.model.MeterBaseUserSpot;
import com.steerinfo.baseinfo.meterbaseuserspotconfig.model.MeterBaseUserSpotConfig;
import com.steerinfo.baseinfo.meterbaseuserspotconfig.service.IMeterBaseUserSpotConfigService;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkcheckfirstactual.model.MeterWorkCheckFirstActual;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterBaseUserSpotConfig RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2023-01-08 11:31
 * 类描述
 * 修订历史：
 * 日期：2023-01-08
 * 作者：generator
 * 参考：
 * 描述：MeterBaseUserSpotConfig RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterbaseuserspotconfigs")
public class MeterBaseUserSpotConfigController extends BaseRESTfulController {

    @Autowired
    IMeterBaseUserSpotConfigService meterBaseUserSpotConfigService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaseuserspotconfig:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseUserSpotConfig> list = meterBaseUserSpotConfigService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaseuserspotconfig:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseUserSpotConfig> list = meterBaseUserSpotConfigService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="创建", notes="根据MeterBaseUserSpotConfig对象创建")
    @ApiImplicitParam(name = "meterBaseUserSpotConfig", value = "详细实体meterBaseUserSpotConfig", required = true, dataType = "MeterBaseUserSpotConfig")
    //@RequiresPermissions("meterbaseuserspotconfig:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterBaseUserSpotConfig model){
        MeterBaseUserSpotConfig meterBaseUserSpotConfig = meterBaseUserSpotConfigService.add(model);
        return success(meterBaseUserSpotConfig);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaseuserspotconfig:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterBaseUserSpotConfig meterBaseUserSpotConfig = meterBaseUserSpotConfigService.getById(id);
        return success(meterBaseUserSpotConfig);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterBaseUserSpotConfig信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterBaseUserSpotConfig", value = "详细实体meterBaseUserSpotConfig", required = true, dataType = "MeterBaseUserSpotConfig")
    })
    //@RequiresPermissions("meterbaseuserspotconfig:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseUserSpotConfig model){
        model.setId(id);
        MeterBaseUserSpotConfig meterBaseUserSpotConfig = meterBaseUserSpotConfigService.modify(model);
        return success(meterBaseUserSpotConfig);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaseuserspotconfig:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterBaseUserSpotConfigService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value="根据用户和计量点ID创建对象", notes="根据sso.sys_user表和meter_base_spot_info表的id创建MeterBaseUserSpotConfig对象")
    @PostMapping(value = "/addModel")
    public RESTfulResult addModel(@RequestBody List<MeterBaseUserSpotConfig> models){
        RESTfulResult rm  = meterBaseUserSpotConfigService.addModel(models);
        return success(rm);
    }

    @ApiOperation(value = "获取列表", notes = "不分页查询")
    @GetMapping(value = "/noPage")
    public RESTfulResult noPage(@RequestParam HashMap parmas) {
        try {
            List<MeterBaseUserSpot> list = meterBaseUserSpotConfigService.noPage(parmas);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @PostMapping(value = "/delete")//String
    public RESTfulResult delete2(@RequestBody List<String> ids){
        try {
            if(ids==null||ids.size()==0){
                return failed("请选择数据！");
            }
            meterBaseUserSpotConfigService.deleteUserSpot(ids);
            //int i=1/0;
            return success(true);
        }catch (Exception e){
            e.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }
}
